#include "mex.h"
#include "f2c.h"

#include <string.h>

void lbfgs_(int* n, int* m, double* x,
	double* f, double* g, int* diagco, double*  diag,
	int* iprint, double* eps, double* xtol, double* wa,
	int* iflag);

void mexFunction(int nlhs, mxArray *plhs[], int nrhs, const mxArray *prhs[])
{
	int i, nf;
	int n, m;
	int maxits=0;
	double eps, xtol;
	double *x, *prx0;
	mxArray *cb_plhs[3];
	mxArray *cb_prhs[2]; /* Changed */
	double f, *g;
	int cb_nlhs;
	int cb_nrhs;
	const char *fn=NULL;
	double *w;
	double *diag, *diagwork;
	int iflag, icall;
	int iprint[2];
	int diagco;

	mxArray *fn_plhs[1];
	mxArray *fn_prhs[1];
	int fn_nlhs;
	int fn_nrhs;

	n=mxGetM(prhs[1]);
	x=mxGetPr(prhs[1]);
	cb_prhs[0]=(mxArray*)prhs[0]; /* Added */
	cb_prhs[1]=mxCreateDoubleMatrix(n, 1, mxREAL); /* Changed */
	prx0=mxGetPr(cb_prhs[1]);
	for(i=0; i<n; i++)
		prx0[i]=x[i];

	cb_nrhs=2; /* Changed */
	cb_nlhs=2;

	m=5;
	maxits=100;
	eps=1e-5;
	xtol=1e-16;
	diagco=0;
	if(nrhs>=3)
	{
		nf=mxGetNumberOfFields(prhs[2]);
		for(i=0; i<nf; i++)
		{
			const char *fname=mxGetFieldNameByNumber(prhs[2], i);
			mxArray *field=mxGetFieldByNumber(prhs[2], 0, i);
			if(!strcmp(fname, "m"))
				m=(int)(mxGetScalar(field));
			else if(!strcmp(fname, "maxits"))
				maxits=(int)(mxGetScalar(field));
			else if(!strcmp(fname, "eps"))
				eps=(mxGetScalar(field));
			else if(!strcmp(fname, "xtol"))
				xtol=(mxGetScalar(field));
			else if(!strcmp(fname, "diagco"))
				diagco=(mxGetScalar(field));
		}
	}
	if(diagco)
		cb_nlhs++;

	/* get the function name of the function handle */
	/* REMOVED */
	//fn_nlhs=1;
	//fn_nrhs=1;
	//fn_prhs[0]=(mxArray*)prhs[0];
	//mexCallMATLAB(fn_nlhs, fn_plhs, fn_nrhs, fn_prhs, "func2str");
	//fn=mxArrayToString(fn_plhs[0]);
	
	w=(double*)mxMalloc(sizeof(double)*(n*(2*m+1)+2*m));
	diagwork=(double*)mxMalloc(sizeof(double)*n);

	iprint[0]=1;
	iprint[1]=0;
	iflag = 0;
	icall = 0;

	while(1)
	{
		mexCallMATLAB(cb_nlhs, cb_plhs, cb_nrhs, cb_prhs, "feval"); /* Changed */
		f=mxGetScalar(cb_plhs[0]);
		g=mxGetPr(cb_plhs[1]);
		if(diagco)
			diag=mxGetPr(cb_plhs[2]);
		else
			diag=diagwork;
		lbfgs_(&n, &m, prx0, &f, g, &diagco, diag, iprint, &eps, &xtol, w, &iflag);
		mxDestroyArray(cb_plhs[0]);
		mxDestroyArray(cb_plhs[1]);
		if(iflag<=0 || icall>=maxits)
			break;
		++icall;
	}
	plhs[0]=mxCreateDoubleMatrix(n, 1, mxREAL);
	x=mxGetPr(plhs[0]);
	for(i=0; i<n; i++)
		x[i]=prx0[i];

	//mxDestroyArray(fn_plhs[0]);
	mxFree(w);
	mxFree(diagwork);
}

